#!/usr/bin/env ruby

#### WARNING
# Any output generated by this file should be reviewed BEFORE
# submission to GitLab Support or any 3rd party. 
# Your company or organization strict definitions as to what
# constitutes sensitive information, and it is your responsibility
# to ensure that you adhere to these guidelines.


require 'optparse'
require 'singleton'

# The module to handle sanitizing
module Sanitizer
  ConfigurationStruct = Struct.new(:domains, :file, :output, :ips, :emails)

  # rubocop:disable Style/ClassVars
  # Class to handle script configuration
  class Configuration
    include Singleton

    @@config = ConfigurationStruct.new
    @@config.domains = false
    @@config.file = '/etc/gitlab/gitlab.rb'
    @@config.output = false
    @@config.ips = false
    @@config.emails = false

    def self.config
      yield(@@config) if block_given?
      @@config
    end

    # rubocop:disable Style/MethodMissingSuper
    def self.method_missing(method, *args, &block)
      respond_to_missing? unless @@config.respond_to? method

      @@config.send(method, *args, &block)
    end
    # rubocop:enable Style/MethodMissingSuper

    def self.respond_to_missing?
      raise NoMethodError
    end
  end
  # rubocop:enable Style/ClassVars

  # Class to parse command line options
  class ConfigurationParser
    def self.parse(args) # rubocop:disable Metrics/MethodLength
      opts = OptionParser.new do |parser|
        parser.separator ''
        parser.separator 'Specific options:'
        parser.on('-f', '--file FILE', "Sanitize FILE (default: #{Configuration.config.file})") do |setting|
          Configuration.file = setting
        end
        parser.on('-s', '--save FILE', 'Save output to FILE (default: outputs to stdout)') do |setting|
          Configuration.output = setting
        end
        parser.on('-d', '--sanitize-domains', 'Sanitize domains') do
          Configuration.domains = true
        end
        parser.on('-i', '--sanitize-ips', 'Sanitize IP addresses') do
          Configuration.ips = true
        end
        parser.on('-e', '--sanitize-emails', 'Sanitize email addresses') do
          Configuration.emails = true
        end
        parser.on_tail('-h', '--help', 'Show this usage message and quit.') do
          puts parser.help
          exit
        end
      end
      opts.parse!(args)
    end
  end

  def sanitize_common(line)
    new_line = line
    patt = /((=\>?|:) *)(['"])[^'"]*(['"])/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /aws_access_key/
    new_line = line.gsub(patt, '\1\3REDACTED ID\4') if line =~ /app_id/
    new_line = line.gsub(patt, '\1\3REDACTED ID\4') if line =~ /tenant_id/
    new_line = line.gsub(patt, '\1\3REDACTED ID\4') if line =~ /client_id/
    new_line = line.gsub(patt, '\1\3REDACTED TOKEN\4') if line =~ /token['":]/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /accesskey/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /secretkey/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /accountkey/
    new_line = line.gsub(patt, '\1\3REDACTED ID\4') if line =~ /gitlab_application_id/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /key_base/
    new_line = line.gsub(patt, '\1\3REDACTED SECRET\4') if line =~ /_secret/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /_key/
    new_line = line.gsub(patt, '\1\3REDACTED KEY\4') if line =~ /bucket/
    new_line = line.gsub(patt, '\1\3REDACTED BIND_DN\4') if line =~ /bind_dn/
    new_line = line.gsub(patt, '\1\3REDACTED ACCOUNT NAME\4') if line =~ /accountname/
    new_line = line.gsub(patt, '\1\3REDACTED ACCOUNT NAME\4') if line =~ /_account_name/
    new_line = line.gsub(patt, '\1\3REDACTED FINGERPRINT\4') if line =~ /_fingerprint/
    
    new_line = new_line.gsub(/(secret:\s+)\S+/, '\1REDACTED SECRET')
    new_line
  end

  def sanitize_domains(line)
    patt = %r{["'](https?):\/\/.+(:[0-9]+)?["']}
    line.gsub(patt, '"\1://REDACTED DOMAIN\2"')
  end

  def sanitize_ips(line)
    line.gsub(/([0-9]{1,3}\.){3}[0-9]{1,3}/, 'REDACTED IP')
  end

  def sanitize_emails(line)
    line.gsub(/= ['"][^@]+@[^'"]+['"]/, "= 'REDACTED EMAIL'")
  end

  def sanitize(line)
    new_line = sanitize_common(line)
    new_line = line.gsub(/(=|:|>) .*/, '\1 "REDACTED PASSWORD"') if line =~ /password/
    new_line = sanitize_domains(new_line) if Configuration.domains
    new_line = sanitize_ips(new_line) if Configuration.ips
    new_line = sanitize_emails(new_line)
    new_line
  end

  def comment?(line)
    line.force_encoding('UTF-8')
    return true if line.strip =~ /^#/

    false
  end

  def whitespace?(line)
    return true if line.gsub(/\s+/, '').empty?

    false
  end

  def run!
    print "Sanitizing #{Configuration.file}..."
    sanitized_content = []
    gitlab_config = IO.readlines(Configuration.file)
    gitlab_config.each do |line|
      next if comment? line

      next if whitespace? line

      sanitized_content.push(sanitize(line))
    end
    puts 'done!'
    if $PROGRAM_NAME == __FILE__
      output(sanitized_content)
    else
      return sanitized_content.join()
    end
  end

  def output(sanitized_content)
    if Configuration.output
      puts "Saving sanitized output to #{Configuration.output}"
      File.open(Configuration.output, 'w') { |f| f.puts(sanitized_content) }
    else
      puts "Printing sanitized #{Configuration.file}"
      puts "\n\n"
      sanitized_content.each { |line| puts line }
      puts "\n\n"
    end
  end
  module_function :run!, :sanitize_common, :sanitize, :comment?, :whitespace?,
                  :output, :sanitize_domains, :sanitize_ips, :sanitize_emails
end

if $PROGRAM_NAME == __FILE__
  Sanitizer::ConfigurationParser.parse(ARGV)
  Sanitizer.run!
end
